// bsl_charconv.h                                                     -*-C++-*-
#ifndef INCLUDED_BSL_CHARCONV
#define INCLUDED_BSL_CHARCONV

#include <bsls_ident.h>
BSLS_IDENT("$Id: $")

//@PURPOSE: Provide functionality of the corresponding C++ Standard header.
//
//@DESCRIPTION: Provide types, in the 'bsl' namespace, equivalent to those
// defined in the corresponding C++ standard header.  In C++17 or later we
// import the 'std' names and earlier we provide our own implementation.

// 'bslstl_charconv.h' will decide whether to use the Bloomberg implementation,
// or forward the implementation from the platform standard library into the
// 'bsl' namespace.

#include <bslstl_charconv.h>

#endif

// ----------------------------------------------------------------------------
// Copyright 2020 Bloomberg Finance L.P.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// ----------------------------- END-OF-FILE ----------------------------------
