// bsl_variant.h                                                      -*-C++-*-
#ifndef INCLUDED_BSL_VARIANT
#define INCLUDED_BSL_VARIANT

#include <bsls_ident.h>
BSLS_IDENT("$Id: $")

//@PURPOSE: Provide functionality of the corresponding C++ Standard header.
//
//@DESCRIPTION: Provide types, in the 'bsl' namespace, equivalent to those
// defined in the corresponding C++ standard header.  Include
// 'bslstl_variant.h', which provides Bloomberg's implementation on all
// platforms.  Include 'bslstl_monostate.h', which uses the native
// compiler-provided standard header when it is available and provides
// Bloomberg's implementation otherwise.

#include <bslstl_monostate.h>
#include <bslstl_variant.h>

#endif

// ----------------------------------------------------------------------------
// Copyright 2023 Bloomberg Finance L.P.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// ----------------------------- END-OF-FILE ----------------------------------
