// bslma_allocator.fwd.h                                              -*-C++-*-
#ifndef FWD_INCLUDED_BSLMA_ALLOCATOR
#define FWD_INCLUDED_BSLMA_ALLOCATOR

//@PURPOSE: Provide forward declarations for memory-allocation mechanisms.
//
//@CLASSES:
//  bslma::Allocator: protocol class for memory allocation and deallocation
//
//@SEE_ALSO: bslma_allocator
//
//@DESCRIPTION: This header provides declarations for those top-level names in
// this component that are intended to be usable in name only.  See above for
// the declared names, and see 'bslma_allocator.h' for documentation of those
// names.


namespace BloombergLP {
namespace bslma {

                          // FORWARD DECLARATIONS

class Allocator;

}  // close package namespace
}  // close enterprise namespace

#endif

// ----------------------------------------------------------------------------
// Copyright 2013 Bloomberg Finance L.P.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// ----------------------------- END-OF-FILE ----------------------------------
