// s_baltst_myenumerationwithfallback.h   *DO NOT EDIT*    @generated -*-C++-*-
#ifndef INCLUDED_S_BALTST_MYENUMERATIONWITHFALLBACK
#define INCLUDED_S_BALTST_MYENUMERATIONWITHFALLBACK

#include <bsls_ident.h>
BSLS_IDENT_RCSID(s_baltst_myenumerationwithfallback_h, "$Id$ $CSID$")
BSLS_IDENT_PRAGMA_ONCE

//@PURPOSE: Provide value-semantic attribute classes

#include <bslalg_typetraits.h>

#include <bdlat_attributeinfo.h>

#include <bdlat_enumeratorinfo.h>

#include <bdlat_typetraits.h>

#include <bsls_assert.h>

#include <bsl_iosfwd.h>
#include <bsl_limits.h>

#include <bsl_ostream.h>
#include <bsl_string.h>

namespace BloombergLP {

namespace s_baltst {

                      // ===============================
                      // class MyEnumerationWithFallback
                      // ===============================

struct MyEnumerationWithFallback {

  public:
    // TYPES
    enum Value {
        VALUE1  = 0
      , VALUE2  = 1
      , UNKNOWN = 2
    };

    enum {
        NUM_ENUMERATORS = 3
    };

    // CONSTANTS
    static const char CLASS_NAME[];

    static const bdlat_EnumeratorInfo ENUMERATOR_INFO_ARRAY[];

    // CLASS METHODS
    static const char *toString(Value value);
        // Return the string representation exactly matching the enumerator
        // name corresponding to the specified enumeration 'value'.

    static int fromString(Value        *result,
                          const char   *string,
                          int           stringLength);
        // Load into the specified 'result' the enumerator matching the
        // specified 'string' of the specified 'stringLength'.  Return 0 on
        // success, and a non-zero value with no effect on 'result' otherwise
        // (i.e., 'string' does not match any enumerator).

    static int fromString(Value              *result,
                          const bsl::string&  string);
        // Load into the specified 'result' the enumerator matching the
        // specified 'string'.  Return 0 on success, and a non-zero value with
        // no effect on 'result' otherwise (i.e., 'string' does not match any
        // enumerator).

    static int fromInt(Value *result, int number);
        // Load into the specified 'result' the enumerator matching the
        // specified 'number'.  Return 0 on success, and a non-zero value with
        // no effect on 'result' otherwise (i.e., 'number' does not match any
        // enumerator).

    static int makeFallback(Value *result);
        // Load into the specified 'result' the fallback enumerator value and
        // return 0 to indicate success.

    static bool hasFallback(Value);
        // Return 'true' to indicate that this type supports a fallback
        // enumerator.

    static bool isFallback(Value value);
        // Return 'true' if the specified 'value' equals the fallback
        // enumerator, and 'false' otherwise.

    static bsl::ostream& print(bsl::ostream& stream, Value value);
        // Write to the specified 'stream' the string representation of
        // the specified enumeration 'value'.  Return a reference to
        // the modifiable 'stream'.
};

// FREE OPERATORS
inline
bsl::ostream& operator<<(bsl::ostream& stream, MyEnumerationWithFallback::Value rhs);
    // Format the specified 'rhs' to the specified output 'stream' and
    // return a reference to the modifiable 'stream'.

}  // close package namespace

// TRAITS

BDLAT_DECL_ENUMERATION_WITH_FALLBACK_TRAITS(s_baltst::MyEnumerationWithFallback)


// ============================================================================
//                         INLINE FUNCTION DEFINITIONS
// ============================================================================

namespace s_baltst {

                      // -------------------------------
                      // class MyEnumerationWithFallback
                      // -------------------------------

// CLASS METHODS
inline
int MyEnumerationWithFallback::fromString(Value *result, const bsl::string& string)
{
    return fromString(result, string.c_str(), static_cast<int>(string.length()));
}

inline
bsl::ostream& MyEnumerationWithFallback::print(bsl::ostream&      stream,
                                 MyEnumerationWithFallback::Value value)
{
    return stream << toString(value);
}

}  // close package namespace

// FREE FUNCTIONS

inline
bsl::ostream& s_baltst::operator<<(
        bsl::ostream& stream,
        s_baltst::MyEnumerationWithFallback::Value rhs)
{
    return s_baltst::MyEnumerationWithFallback::print(stream, rhs);
}

}  // close enterprise namespace
#endif

// GENERATED BY @BLP_BAS_CODEGEN_VERSION@
// USING bas_codegen.pl s_baltst_myenumerationwithfallback.xsd --mode msg --includedir . --msgComponent myenumerationwithfallback --noRecurse --noExternalization --noHashSupport --noAggregateConversion
// ----------------------------------------------------------------------------
// NOTICE:
//      Copyright 2023 Bloomberg Finance L.P. All rights reserved.
//      Property of Bloomberg Finance L.P. (BFLP)
//      This software is made available solely pursuant to the
//      terms of a BFLP license agreement which governs its use.
// ------------------------------- END-OF-FILE --------------------------------
