# - Config file for the FooBar package
# It defines the following variables
#  bal_INCLUDE_DIRS - include directories for FooBar
#  bal_LIBRARIES    - libraries to link against

include(CMakeFindDependencyMacro)

# Compute paths
get_filename_component(bal_CMAKE_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)

if(NOT TARGET bal AND NOT bal_BINARY_DIR)
  if(NOT WIN32)
    find_dependency(Threads)
  endif()
  foreach(dep bdl;bsl)
    find_dependency(${dep} PATHS ${CMAKE_CURRENT_LIST_DIR})
  endforeach()

  include("${bal_CMAKE_DIR}/balInterfaceTargets.cmake" OPTIONAL)
  include("${bal_CMAKE_DIR}/balTargets.cmake")
endif()
