# - Config file for the FooBar package
# It defines the following variables
#  bdl_INCLUDE_DIRS - include directories for FooBar
#  bdl_LIBRARIES    - libraries to link against

include(CMakeFindDependencyMacro)

# Compute paths
get_filename_component(bdl_CMAKE_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)

if(NOT TARGET bdl AND NOT bdl_BINARY_DIR)
  if(NOT WIN32)
    find_dependency(Threads)
  endif()
  foreach(dep bsl;inteldfp;libpcre2-posix)
    find_dependency(${dep} PATHS ${CMAKE_CURRENT_LIST_DIR})
  endforeach()

  include("${bdl_CMAKE_DIR}/bdlInterfaceTargets.cmake" OPTIONAL)
  include("${bdl_CMAKE_DIR}/bdlTargets.cmake")
endif()
