# - Config file for the FooBar package
# It defines the following variables
#  inteldfp_INCLUDE_DIRS - include directories for FooBar
#  inteldfp_LIBRARIES    - libraries to link against

include(CMakeFindDependencyMacro)

# Compute paths
get_filename_component(inteldfp_CMAKE_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)

if(NOT TARGET inteldfp AND NOT inteldfp_BINARY_DIR)
  if(NOT WIN32)
    find_dependency(Threads)
  endif()
  foreach(dep )
    find_dependency(${dep} PATHS ${CMAKE_CURRENT_LIST_DIR})
  endforeach()

  include("${inteldfp_CMAKE_DIR}/inteldfpInterfaceTargets.cmake" OPTIONAL)
  include("${inteldfp_CMAKE_DIR}/inteldfpTargets.cmake")
endif()
