# - Config file for the FooBar package
# It defines the following variables
#  ryu_INCLUDE_DIRS - include directories for FooBar
#  ryu_LIBRARIES    - libraries to link against

include(CMakeFindDependencyMacro)

# Compute paths
get_filename_component(ryu_CMAKE_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)

if(NOT TARGET ryu AND NOT ryu_BINARY_DIR)
  if(NOT WIN32)
    find_dependency(Threads)
  endif()
  foreach(dep )
    find_dependency(${dep} PATHS ${CMAKE_CURRENT_LIST_DIR})
  endforeach()

  include("${ryu_CMAKE_DIR}/ryuInterfaceTargets.cmake" OPTIONAL)
  include("${ryu_CMAKE_DIR}/ryuTargets.cmake")
endif()
